﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
    Type  TOnkyoCmd(Master  As Boolean,     _           '  Is this a Master or Zone Command
                    Cmd     As String,      _           '  The Onkyo Command
                    Verbose As String)                  '  The Onkyo Command Meaning


	Public  IsInitialized									As Boolean = False

    Private mOnkyoCmds                                     	As List
	
	Private mInputSelector_ByValue							As Map 		
	Private	mInputSelector_ByName							As Map	
	
	Private mListeningMode_ByValue							As Map 				
End Sub


Public  Sub Initialize
            IsInitialized   = True

            MakeOnkyoCmds
			MakeOnkyoMaps
End Sub

Public  Sub FindCmd(Cmd As String) As TOnkyoCmd
            Dim OnkyoCmd As TOnkyoCmd

            If  IsInitialized = False Then
                Initialize
            End If

            If  mOnkyoCmds.IsInitialized = False Then
                OnkyoCmd.Initialize
                OnkyoCmd.Cmd        = "???"
                OnkyoCmd.Verbose    = "For some reason Onkyo Cmd list is not Initialized"

                Return OnkyoCmd
            End If

            For i = 0 To mOnkyoCmds.Size-1
                OnkyoCmd = mOnkyoCmds.Get(i)

                If  OnkyoCmd.Cmd.EqualsIgnoreCase(Cmd) Then
                    Return OnkyoCmd
                End If
            Next

            OnkyoCmd.Initialize
            OnkyoCmd.Cmd        = Cmd
            OnkyoCmd.Verbose    = "Onkyo Cmd NOT Found in List"

            Return OnkyoCmd
End Sub

Public  Sub FindInputSelectorByName(InputSelector As String) As Boolean

            If  IsInitialized = False Then
                Initialize
            End If

			Return mInputSelector_ByName.ContainsKey(InputSelector)			
End Sub

Public  Sub GetInputSelectorByName(InputSelector As String) As String

            If  IsInitialized = False Then
                Initialize
            End If

			Dim InputSelectorCmd As Object = mInputSelector_ByName.Get(InputSelector)			
			
			If  InputSelectorCmd = Null Then
				InputSelectorCmd = "???[" &InputSelector &"]"
			End If
			
			Return InputSelectorCmd
End Sub

Public  Sub FindInputSelectorByValue(InputSelector As String) As Boolean

            If  IsInitialized = False Then
                Initialize
            End If

			Return mInputSelector_ByValue.ContainsKey(InputSelector)			
End Sub

Public  Sub GetInputSelectorByValue(InputSelector As String) As String

            If  IsInitialized = False Then
                Initialize
            End If

			Dim InputSelectorCmd As Object = mInputSelector_ByValue.Get(InputSelector)			
			
			If  InputSelectorCmd = Null Then
				InputSelectorCmd = "???[" &InputSelector &"]"
			End If
			
			Return InputSelectorCmd
End Sub

Public  Sub GetListeningModeByValue(InputSelector As String) As String

            If  IsInitialized = False Then
                Initialize
            End If

			Dim InputSelectorCmd As Object = mListeningMode_ByValue.Get(InputSelector)			
			
			If  InputSelectorCmd = Null Then
				InputSelectorCmd = "???[" &InputSelector &"]"
			End If
			
			Return InputSelectorCmd
End Sub

Public  Sub FindListeningModeByValue(InputSelector As String) As Boolean

            If  IsInitialized = False Then
                Initialize
            End If

			Return mListeningMode_ByValue.ContainsKey(InputSelector)			
End Sub



Private Sub MakeOnkyoCmd(Master As Boolean, Cmd As String, Verbose As String) As TOnkyoCmd
            Dim OnkyoCmd As TOnkyoCmd

            OnkyoCmd.Initialize
            OnkyoCmd.Master         = Master
            OnkyoCmd.Cmd            = Cmd
            OnkyoCmd.Verbose        = Verbose

            Return OnkyoCmd
End Sub

Private Sub MakeOnkyoCmds
            mOnkyoCmds.Initialize

            mOnkyoCmds.AddAll(Array As TOnkyoCmd(MakeOnkyoCmd(True,  "ACE", "All Channel EQ"                               ),        _
                                                 MakeOnkyoCmd(True,  "AEQ", "AccuEQ"                                       ),        _
                                                 MakeOnkyoCmd(True,  "AMT", "Audio Muting Command"                         ),        _
                                                 MakeOnkyoCmd(True,  "APD", "Auto Power Down"                              ),        _
                                                 MakeOnkyoCmd(True,  "ARC", "Audio Return Channel"                         ),        _
                                                 MakeOnkyoCmd(True,  "ASC", "Audio Scalar"                                 ),        _
                                                 MakeOnkyoCmd(True,  "AVS", "A/V Sync"                                     ),        _
                                                 MakeOnkyoCmd(True,  "CEC", "HDMI CEC"                                     ),        _
                                                 MakeOnkyoCmd(True,  "CMT", "Audio Muting by Channel Command"              ),        _
                                                 MakeOnkyoCmd(True,  "CTI", "Center Image for Neo:6 Music"                 ),        _
                                                 MakeOnkyoCmd(True,  "CTL", "Center (temporary) Level Command"             ),        _
                                                 MakeOnkyoCmd(True,  "CTS", "Cener Spread for Dolby Surround"              ),        _
                                                 MakeOnkyoCmd(True,  "CTW", "Center Width for PLII Music"                  ),        _
                                                 MakeOnkyoCmd(True,  "DCE", "Dialog Control Enabled"                       ),        _
                                                 MakeOnkyoCmd(True,  "DGF", "Digital Filter"                               ),        _
                                                 MakeOnkyoCmd(True,  "DIF", "Display Information Command"                  ),        _
                                                 MakeOnkyoCmd(True,  "DIF", "Display Mode Command"                         ),        _
                                                 MakeOnkyoCmd(True,  "DIM", "Dimmer Level Command"                         ),        _
                                                 MakeOnkyoCmd(True,  "DLC", "Dialog Control"                               ),        _
                                                 MakeOnkyoCmd(True,  "DMN", "Input Channel (Multiplex) / Dual Mono"        ),        _
                                                 MakeOnkyoCmd(True,  "DMS", "Dimension for PLII Music"                     ),        _
                                                 MakeOnkyoCmd(True,  "ECO", "for Smart Grid Command"                       ),        _
                                                 MakeOnkyoCmd(True,  "FLD", "FL Display Infomation Command"                ),        _
                                                 MakeOnkyoCmd(True,  "FWV", "Firmware Version"                             ),        _
                                                 MakeOnkyoCmd(True,  "FXP", "PCM Fixed Mode / Fixed PCM Mode"              ),        _
                                                 MakeOnkyoCmd(True,  "HAO", "HDMI Audio Out (Main)"                        ),        _
                                                 MakeOnkyoCmd(True,  "HAS", "HDMI Audio Out (Sub)"                         ),        _
                                                 MakeOnkyoCmd(True,  "HBT", "Hi-Bit"                                       ),        _
                                                 MakeOnkyoCmd(True,  "HDO", "HDMI Output Selector"                         ),        _
                                                 MakeOnkyoCmd(True,  "HOI", "HDMI Out Information"                         ),        _
                                                 MakeOnkyoCmd(True,  "HST", "HDMI Standby Through"                         ),        _
                                                 MakeOnkyoCmd(True,  "IFA", "Audio Infomation Command"                     ),        _
                                                 MakeOnkyoCmd(True,  "IFV", "Video Infomation Command"                     ),        _
                                                 MakeOnkyoCmd(True,  "IRN", "Input Selector Rename / Input Function Rename"),        _
                                                 MakeOnkyoCmd(True,  "ITV", "IntelliVolume / Input Level Absorber"         ),        _
                                                 MakeOnkyoCmd(True,  "LDM", "Loudness Management"                          ),        _
                                                 MakeOnkyoCmd(True,  "LFE", "LFE Level / LFE Mute Level"                   ),        _
                                                 MakeOnkyoCmd(True,  "LMD", "Listening Mode Command"                       ),        _
                                                 MakeOnkyoCmd(True,  "LPS", "Lip Sync / Auto Delay"                        ),        _
                                                 MakeOnkyoCmd(True,  "LTN", "Late Night Command"                           ),        _
                                                 MakeOnkyoCmd(True,  "MCC", "MCACC Calibration"                            ),        _
                                                 MakeOnkyoCmd(True,  "MCM", "MCACC MEMORY"                                 ),        _
                                                 MakeOnkyoCmd(True,  "MEM", "Memory Setup Command"                         ),        _
                                                 MakeOnkyoCmd(True,  "MFB", "Fullband MCACC Calibration"                   ),        _
                                                 MakeOnkyoCmd(True,  "MOT", "Music Optimizer / Sound Retriever"            ),        _
                                                 MakeOnkyoCmd(True,  "MVL", "Master Volume Command"                        ),        _
                                                 MakeOnkyoCmd(True,  "OSD", "Setup Operation Command"                      ),        _
                                                 MakeOnkyoCmd(True,  "PAM", "Pre Amp Mode / AMP Mode"                      ),        _
                                                 MakeOnkyoCmd(True,  "PCP", "Phase Control Plus"                           ),        _
                                                 MakeOnkyoCmd(True,  "PCT", "Phase Control"                                ),        _
                                                 MakeOnkyoCmd(True,  "PMB", "Phase Matching Bass Command"                  ),        _
                                                 MakeOnkyoCmd(True,  "PNR", "Panorama for PLII Music"                      ),        _
                                                 MakeOnkyoCmd(True,  "POP", "Popup Message"                                ),        _
                                                 MakeOnkyoCmd(True,  "PQL", "PQLS"                                         ),        _
                                                 MakeOnkyoCmd(True,  "PRM", "Preset Memory Command"                        ),        _
                                                 MakeOnkyoCmd(True,  "PRS", "Preset Command"                               ),        _
                                                 MakeOnkyoCmd(True,  "PTS", "PTY Scan Command"                             ),        _
                                                 MakeOnkyoCmd(True,  "PWR", "System Power Command"                         ),        _
                                                 MakeOnkyoCmd(True,  "RAS", "Cinema Filter Command"                        ),        _
                                                 MakeOnkyoCmd(True,  "RAS", "Re-EQ Command"                                ),        _
                                                 MakeOnkyoCmd(True,  "RDS", "RDS Information Command"                      ),        _
                                                 MakeOnkyoCmd(True,  "RES", "Monitor Out Resolution"                       ),        _
                                                 MakeOnkyoCmd(True,  "RST", "Reset Command"                                ),        _
                                                 MakeOnkyoCmd(True,  "SCD", "Screen Centered Dialog / Dialog Enahncement"  ),        _
                                                 MakeOnkyoCmd(True,  "SLA", "Audio Selector Command"                       ),        _
                                                 MakeOnkyoCmd(True,  "SLC", "Speaker Level Calibration Command"            ),        _
                                                 MakeOnkyoCmd(True,  "SLI", "Input Selector Command"                       ),        _
                                                 MakeOnkyoCmd(True,  "SLP", "Sleep Set Command"                            ),        _
                                                 MakeOnkyoCmd(True,  "SPD", "Speaker Distance Command"                     ),        _
                                                 MakeOnkyoCmd(True,  "SPI", "Speaker Information"                          ),        _
                                                 MakeOnkyoCmd(True,  "SPL", "Speaker Layout Command"                       ),        _
                                                 MakeOnkyoCmd(True,  "SPR", "Super Resolution"                             ),        _
                                                 MakeOnkyoCmd(True,  "STW", "EQ for Standing Wave / Standing Wave"         ),        _
                                                 MakeOnkyoCmd(True,  "SW2", "Subwoofer 2 (temporary) Level Command"        ),        _
                                                 MakeOnkyoCmd(True,  "SWL", "Subwoofer (temporary) Level Command"          ),        _
                                                 MakeOnkyoCmd(True,  "TCL", "Temporary Channel Level Command"              ),        _
                                                 MakeOnkyoCmd(True,  "TCT", "Tone(Center) Command"                         ),        _
                                                 MakeOnkyoCmd(True,  "TFH", "Tone(Front High) Command"                     ),        _
                                                 MakeOnkyoCmd(True,  "TFR", "Tone(Front) Command"                          ),        _
                                                 MakeOnkyoCmd(True,  "TFW", "Tone(Front Wide) Command"                     ),        _
                                                 MakeOnkyoCmd(True,  "TGA", "12V Trigger A Command"                        ),        _
                                                 MakeOnkyoCmd(True,  "TGB", "12V Trigger B Command"                        ),        _
                                                 MakeOnkyoCmd(True,  "TGC", "12V Trigger C Command"                        ),        _
                                                 MakeOnkyoCmd(True,  "TSB", "Tone(Surround Back) Command"                  ),        _
                                                 MakeOnkyoCmd(True,  "TSR", "Tone(Surround) Command"                       ),        _
                                                 MakeOnkyoCmd(True,  "TSW", "Tone(Subwoofer) Command"                      ),        _
                                                 MakeOnkyoCmd(True,  "TUN", "Tuning Command"                               ),        _
                                                 MakeOnkyoCmd(True,  "UPD", "Update"                                       ),        _
                                                 MakeOnkyoCmd(True,  "UPS", "Upsampling"                                   ),        _
                                                 MakeOnkyoCmd(False, "NPZ", "Internet Radio Preset Command"                ),        _
                                                 MakeOnkyoCmd(False, "NTZ", "Net-Tune/Network Operation Command"           ),        _
                                                 MakeOnkyoCmd(False, "PRZ", "Preset Command"                               ),        _
                                                 MakeOnkyoCmd(False, "SLZ", "ZONE2 Selector Command"                       ),        _
                                                 MakeOnkyoCmd(False, "TUZ", "Tuning Command"                               ),        _
                                                 MakeOnkyoCmd(False, "ZBL", "Zone2 Balance Command"                        ),        _
                                                 MakeOnkyoCmd(False, "ZMT", "Zone2 Muting Command"                         ),        _
                                                 MakeOnkyoCmd(False, "ZPW", "Zone2 Power Command"                          ),        _
                                                 MakeOnkyoCmd(False, "ZTN", "Zone2 Tone Command"                           ),        _
                                                 MakeOnkyoCmd(False, "ZVL", "Zone2 Volume Command"                         )))

            mOnkyoCmds.SortType("Cmd", True)
End Sub

Private Sub MakeOnkyoMaps
			mInputSelector_ByValue.Initialize
			mInputSelector_ByValue.Put("00",		 				"VIDEO1	VCR/DVR")
			mInputSelector_ByValue.Put("01", 						"VIDEO2	CBL/Sat")
			mInputSelector_ByValue.Put("02", 						"VIDEO3	GAME/TV")
			mInputSelector_ByValue.Put("05", 						"VIDEO6	PC")
			mInputSelector_ByValue.Put("10", 						"DVD	BD/DVD")
			mInputSelector_ByValue.Put("20",	 					"TAPE1 (TAPE) TV/TAPE")
			mInputSelector_ByValue.Put("22",	 					"PHONO")
			mInputSelector_ByValue.Put("23", 						"CD")
			mInputSelector_ByValue.Put("24",						"FM")
			mInputSelector_ByValue.Put("25", 						"AM")
			mInputSelector_ByValue.Put("26",	 					"TUNER")
			mInputSelector_ByValue.Put("27",	 					"MUSIC SERVER")
			mInputSelector_ByValue.Put("28", 						"INTERNET RADIO")
			mInputSelector_ByValue.Put("29", 						"USB/USB(Front)")
			mInputSelector_ByValue.Put("2A", 						"USB(Rear)")
			mInputSelector_ByValue.Put("2B", 						"NETWORK")
			mInputSelector_ByValue.Put("2C",	 					"USB")
			mInputSelector_ByValue.Put("2E", 						"Bluetooth")
			mInputSelector_ByValue.Put("40", 						"Universal")
			mInputSelector_ByValue.Put("31", 						"XM")
			mInputSelector_ByValue.Put("32",	 					"SIRIUS")
			mInputSelector_ByValue.Put("33", 						"DAB")	
			mInputSelector_ByValue.Put("UP",						"Input Selector Up")
			mInputSelector_ByValue.Put("DOWN",						"Input Selector Down")
			mInputSelector_ByValue.Put("QSTN",						"Input Selector Status")
            
			mInputSelector_ByName.Initialize
			mInputSelector_ByName.Put("VCR/DVR",					"00")
			mInputSelector_ByName.Put("CBL/Sat",					"01")
			mInputSelector_ByName.Put("Game/TV",	 				"02")
			mInputSelector_ByName.Put("PC",							"05")
			mInputSelector_ByName.Put("BD/DVD",						"10")
			mInputSelector_ByName.Put("TV/Tape",					"20")
			mInputSelector_ByName.Put("Phono",						"22")
			mInputSelector_ByName.Put("CD",							"23")
			mInputSelector_ByName.Put("FM",							"24")
			mInputSelector_ByName.Put("AM",							"25")
			mInputSelector_ByName.Put("Tuner",						"26")
			mInputSelector_ByName.Put("Music Server",				"27")
			mInputSelector_ByName.Put("Internet Radio",				"28")
			mInputSelector_ByName.Put("USB(Front)",					"29")
			mInputSelector_ByName.Put("USB(Rear)",					"2A")
			mInputSelector_ByName.Put("Network",					"2B")
			mInputSelector_ByName.Put("USB",						"2C")
			mInputSelector_ByName.Put("Bluetooth",					"2E")
			mInputSelector_ByName.Put("Universal",					"40")
			mInputSelector_ByName.Put("XM",							"31")
			mInputSelector_ByName.Put("Sirius",						"32")
			mInputSelector_ByName.Put("DAB",						"33")	
			mInputSelector_ByName.Put("Input Selector Up", 			"UP")
			mInputSelector_ByName.Put("Input Selector Down",		"DOWN")
			mInputSelector_ByName.Put("Input Selector Status", 		"QSTN")
            
			mListeningMode_ByValue.Initialize
			mListeningMode_ByValue.Put("00",						"STEREO")
			mListeningMode_ByValue.Put("01",						"DIRECT")
			mListeningMode_ByValue.Put("02",						"SURROUND")
			mListeningMode_ByValue.Put("03",						"FILM Game-RPG")
			mListeningMode_ByValue.Put("04",						"THX")
			mListeningMode_ByValue.Put("05",						"ACTION Game-Action")
			mListeningMode_ByValue.Put("06",						"MUSICAL Game-Rock")
			mListeningMode_ByValue.Put("07",						"MONO MOVIE")
			mListeningMode_ByValue.Put("08",						"ORCHESTRA")
			mListeningMode_ByValue.Put("09",						"UNPLUGGED")
			mListeningMode_ByValue.Put("0A",						"STUDIO-MIX")
			mListeningMode_ByValue.Put("0B",						"TV LOGIC")
			mListeningMode_ByValue.Put("0C",						"ALL CH STEREO")
			mListeningMode_ByValue.Put("0D",						"THEATER-DIMENSIONAL")
			mListeningMode_ByValue.Put("0E",						"ENHANCED 7/ENHANCE Game-Sports")
			mListeningMode_ByValue.Put("0F",						"MONO")
			mListeningMode_ByValue.Put("11",						"PURE AUDIO")
			mListeningMode_ByValue.Put("12",						"MULTIPLEX")
			mListeningMode_ByValue.Put("13",						"FULL MONO")
			mListeningMode_ByValue.Put("14",						"DOLBY VIRTUAL")
			mListeningMode_ByValue.Put("15",						"DTS Surround Sensation")
			mListeningMode_ByValue.Put("16",						"Audyssey DSX")
			mListeningMode_ByValue.Put("40",						"5.1ch Surround")
			mListeningMode_ByValue.Put("40",						"Straight Decode*1")
			mListeningMode_ByValue.Put("41",						"Dolby EX/DTS ES")
			mListeningMode_ByValue.Put("41",						"Dolby EX*2")
			mListeningMode_ByValue.Put("42",						"THX Cinema")
			mListeningMode_ByValue.Put("43",						"THX Surround EX")
			mListeningMode_ByValue.Put("44",						"THX Music")
			mListeningMode_ByValue.Put("45",						"THX Games")
			mListeningMode_ByValue.Put("50",						"U2/S2 Cinema/Cinema2")
			mListeningMode_ByValue.Put("51",						"MusicMode,U2/S2 Music")
			mListeningMode_ByValue.Put("52",						"Games Mode,U2/S2 Games")
			mListeningMode_ByValue.Put("80",						"PLII/PLIIx Movie")
			mListeningMode_ByValue.Put("81",						"PLII/PLIIx Music")
			mListeningMode_ByValue.Put("82",						"Neo:6 Cinema")
			mListeningMode_ByValue.Put("83",						"Neo:6 Music")
			mListeningMode_ByValue.Put("84",						"PLII/PLIIx THX Cinema")
			mListeningMode_ByValue.Put("85",						"Neo:6 THX Cinema")
			mListeningMode_ByValue.Put("86",						"PLII/PLIIx Game")
			mListeningMode_ByValue.Put("87",						"Neural Surr*3")
			mListeningMode_ByValue.Put("88",						"Neural THX/Neural Surround")
			mListeningMode_ByValue.Put("89",						"PLII/PLIIx THX Games")
			mListeningMode_ByValue.Put("8A",						"Neo:6 THX Games")
			mListeningMode_ByValue.Put("8B",						"PLII/PLIIx THX Music")
			mListeningMode_ByValue.Put("8C",						"Neo:6 THX Music")
			mListeningMode_ByValue.Put("8D",						"Neural THX Cinema")
			mListeningMode_ByValue.Put("8E",						"Neural THX Music")
			mListeningMode_ByValue.Put("8F",						"Neural THX Games")
			mListeningMode_ByValue.Put("90",						"PLIIz Height")
			mListeningMode_ByValue.Put("91",						"Neo:6 Cinema DTS Surround Sensation")
			mListeningMode_ByValue.Put("92",						"Neo:6 Music DTS Surround Sensation")
			mListeningMode_ByValue.Put("93",						"Neural Digital Music")
			mListeningMode_ByValue.Put("94",						"PLIIz Height + THX Cinema")
			mListeningMode_ByValue.Put("95",						"PLIIz Height + THX Music")
			mListeningMode_ByValue.Put("96",						"PLIIz Height + THX Games")
			mListeningMode_ByValue.Put("97",						"PLIIz Height + THX U2/S2 Cinema")
			mListeningMode_ByValue.Put("98",						"PLIIz Height + THX U2/S2 Music")
			mListeningMode_ByValue.Put("99",						"PLIIz Height + THX U2/S2 Games")
			mListeningMode_ByValue.Put("A0",						"PLIIx/PLII Movie + Audyssey DSX")
			mListeningMode_ByValue.Put("A1",						"PLIIx/PLII Music + Audyssey DSX")
			mListeningMode_ByValue.Put("A2",						"PLIIx/PLII Game + Audyssey DSX")
			mListeningMode_ByValue.Put("A3",						"Neo:6 Cinema + Audyssey DSX")
			mListeningMode_ByValue.Put("A4",						"Neo:6 Music + Audyssey DSX")
			mListeningMode_ByValue.Put("A5",						"Neural Surround + Audyssey DSX")
			mListeningMode_ByValue.Put("A6",						"Neural Digital Music + Audyssey DSX")
			mListeningMode_ByValue.Put("A7",						"Dolby EX + Audyssey DSX")			
			mListeningMode_ByValue.Put("UP",						"Listening Mode Up")
			mListeningMode_ByValue.Put("DOWN",						"Listening Mode Down")
			mListeningMode_ByValue.Put("MOVIE",						"Listening Mode Movie")
			mListeningMode_ByValue.Put("MUSIC",						"Listening Mode Music")
			mListeningMode_ByValue.Put("GAME",						"Listening Mode Game")
			mListeningMode_ByValue.Put("QSTN",						"The Listening Mode Status")
End Sub

